# Импорт недавно установленного пакета setuptools.
import setuptools

# Определение requests как requirements для того, чтобы этот пакет работал. Зависимости проекта.
requirements = ["cryptography<=3.4.8"]

# Функция, которая принимает несколько аргументов. Она присваивает эти значения пакету.
setuptools.setup(
    # Имя дистрибутива пакета. Оно должно быть уникальным, поэтому добавление вашего имени пользователя в конце является обычным делом.
    name="mstp",
    # Номер версии вашего пакета. Обычно используется семантическое управление версиями.
    version="0.2.0",
    # Имя автора.
    author="m5k",
    # Его почта.
    author_email="spam@m5k.ru",
    # Краткое описание, которое будет показано на странице PyPi.
    description="secure data transfer protocol",
    # Длинное описание, которое будет отображаться на странице PyPi. Использует README.md репозитория для заполнения.
    long_description="",
    # Определяет тип контента, используемый в long_description.
    long_description_content_type="text/markdown",
    # URL-адрес, представляющий домашнюю страницу проекта. Большинство проектов ссылаются на репозиторий.
    url="",
    # Находит все пакеты внутри проекта и объединяет их в дистрибутив.
    packages=setuptools.find_packages(),
    # requirements или dependencies, которые будут установлены вместе с пакетом, когда пользователь установит его через pip.
    install_requires=requirements,
    # Предоставляет pip некоторые метаданные о пакете. Также отображается на странице PyPi.
    classifiers=[
        "Programming Language :: Python :: 3.8",
        "License :: OSI Approved :: MIT License",
        "Operating System :: OS Independent",
    ],
    # Требуемая версия Python.
    python_requires='>=3.6',
)
